unit ChannelConfigFrameUnit;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TChannelConfigFrame = class(TFrame)
    ChLabel: TLabel;
    TareButton: TButton;
    Label1: TLabel;
    ScaleEdit: TEdit;
    procedure TareButtonClick(Sender: TObject);
    procedure ScaleEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    Index: Integer;
    { Public declarations }
  end;

type
  TChannelData = record
    Code: Word;
    Tare: Word;
    Scale: Real;
    Frame: TChannelConfigFrame;
  end;

var
  ChannelData: array[0..12] of TChannelData = (
    ( Code: $0000; Scale: 1/1400; ),
    ( Code: $1000; Scale: 1/1400; ),
    ( Code: $2000; Scale: 1/1400; ),
    ( Code: $3000; Scale: 1/1400; ),
    ( Code: $4000; Scale: 1/1400; ),
    ( Code: $5000; Scale: 1/1400; ),
    ( Code: $6000; Scale: 1/1400; ),
    ( Code: $7000; Scale: 1/1400; ),
    ( Code: $0014; Scale: 1; ), //Temperature reference.
    ( Code: $2010; Scale: 1; ),
    ( Code: $4010; Scale: 1; ),
    ( Code: $6010; Scale: 1; ),
    ( Code: $7010; Scale: 1; )
  );

implementation

{$R *.DFM}

uses
  MainUnit;

procedure TChannelConfigFrame.TareButtonClick(Sender: TObject);
begin
  MainForm.DoTare(Index);
end;

procedure TChannelConfigFrame.ScaleEditChange(Sender: TObject);
begin
  try
    ChannelData[Index].Scale := 1 / StrToFloat(ScaleEdit.Text);

    ScaleEdit.Color := clWindow;
    ScaleEdit.ParentFont := True;
  except
    ScaleEdit.Color := $000080;
    ScaleEdit.Font.Color := $FFFFFF;
  end;
end;

end.
